--- memsize.c-backup	Fri Apr  2 12:25:40 2004
+++ memsize.c	Fri Apr  2 13:09:28 2004
@@ -59,9 +59,11 @@ long get_ram_size(volatile long *base, l
 
 	for (cnt = 1; cnt < maxsize / sizeof (long); cnt <<= 1) {
 		addr = base + cnt;	/* pointer arith! */
-		val = *addr;
-		*addr = save[--i];
-		if (val != ~cnt) {
+		if (addr < maxsize) {
+			val = *addr;
+			*addr = save[--i];
+		}
+		if (val != ~cnt || addr >= maxsize) {
 			size = cnt * sizeof (long);
 			/* Restore the original data before leaving the function.
 			 */
